#include <stdio.h>
#include <stdlib.h>
#include <sys/comm.h>

#include "escape.h"
#include "esclib.h"
#include "screen.h"

/* ץ󥹤νѥХåե */
int escseq_length = 0;
char escseq_buffer[20] = "\0";

int cursol_send_mode = 0; /* DECѥ⡼ɤΥץꥱ⡼ */

/*  */
int escape_args[20];

/* ץ󥹤ν */
void parse_escseq()
{
  int tmp1, tmp2;
  int dec_mode = 0; /* DECѥ⡼ */
  char command;

  if (escseq_length < 3) return;
  if (escseq_buffer[0] != ESCAPE_CODE) return;
  if (escseq_buffer[1] != '[') return;
  if (escseq_buffer[2] == '?') dec_mode = 1;

  command = make_args();

  tmp1 = escape_args[0];
  tmp2 = escape_args[1];

  switch (command) {

  case 'n': /* ESC[n ɸ */
    escape_send_stat(tmp1);
    break;

  case 'A': /* ESC[A ˰ư */
    if (tmp1 < 0) tmp1 = 1;
    cursol_up(tmp1);
    break;

  case 'B': /* ESC[B 򲼤˰ư */
  case 'e': /* ESC[e 򲼤˰ư */
    if (tmp1 < 0) tmp1 = 1;
    cursol_down(tmp1);
    break;

  case 'C': /* ESC[C 򱦤˰ư */
  case 'a': /* ESC[a 򱦤˰ư */
    if (tmp1 < 0) tmp1 = 1;
    cursol_right(tmp1);
    break;

  case 'D': /* ESC[D 򺸤˰ư */
    if (tmp1 < 0) tmp1 = 1;
    cursol_left(tmp1);
    break;

  case 'G': /* ESC[G xɸ */
    tmp1--;
    if (tmp1 < 0) tmp1 = 0;
    cursol_set_x(tmp1);
    break;

  case 'd': /* ESC[d yɸ */
    tmp1--;
    if (tmp1 < 0) tmp1 = 0;
    cursol_set_y(tmp1);
    break;

  case 'E': /* ESC[E par1ԲƬ˰ư */
    if (tmp1 < 0) tmp1 = 1;
    cursol_down(tmp1);
    cursol_set_x(0);
    break;

  case 'F': /* ESC[F par1ԾƬ˰ư */
    if (tmp1 < 0) tmp1 = 1;
    cursol_up(tmp1);
    cursol_set_x(0);
    break;

  case 'H': /* ESC[<row>;<col>H ꤷɸ˰ư */
    tmp1--;
    tmp2--;
    if (tmp1 < 0) tmp1 = 0;
    if (tmp2 < 0) tmp2 = 0;
    cursol_set(tmp2, tmp1);
    break;

  case 'J': /* ESC[J ꥢ */
    if (tmp1 < 0) tmp1 = 0;
    escape_screen_clear(tmp1);
    break;

  case 'K': /* ESC[K ꥢ */
    if (tmp1 < 0) tmp1 = 0;
    escape_line_clear(tmp1);
    break;

  case 'L': /* ESC[L Ԥ */
  case 'M': /* ESC[M Ԥκ */
    if (tmp1 < 0) tmp1 = 1;
    escape_ins_del(command, tmp1);
    break;

  case 'h': /* ESC[?h DECѥ⡼ */
  case 'l': /* ESC[?l DECѥ⡼ɥꥢ */
    if (!dec_mode) break;
    parse_dec_escseq(command, escape_args[1]);
    break;
  }
}

/* End of Program  */
